#ifndef lint
/*static char yysccsid[] = "from: @(#)yaccpar	1.9 (Berkeley) 02/21/93";*/
static char yyrcsid[] = "$Id: skeleton.c,v 1.4 1993/12/21 18:45:32 jtc Exp $";
#endif
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING (yyerrflag!=0)
#define YYPREFIX "yy"

    /* This file is a transformation of James A. Roskind's C++ grammar */


    /* Copyright (C) 1989,1990 James A. Roskind, All rights reserved.
    This grammar was developed  and  written  by  James  A.  Roskind.
    Copying  of  this  grammar  description, as a whole, is permitted
    providing this notice is intact and applicable  in  all  complete
    copies.   Translations as a whole to other parser generator input
    languages  (or  grammar  description  languages)   is   permitted
    provided  that  this  notice is intact and applicable in all such
    copies,  along  with  a  disclaimer  that  the  contents  are   a
    translation.   The reproduction of derived text, such as modified
    versions of this grammar, or the output of parser generators,  is
    permitted,  provided  the  resulting  work includes the copyright
    notice "Portions Copyright (c)  1989,  1990  James  A.  Roskind".
    Derived products, such as compilers, translators, browsers, etc.,
    that  use  this  grammar,  must also provide the notice "Portions
    Copyright  (c)  1989,  1990  James  A.  Roskind"  in   a   manner
    appropriate  to  the  utility,  and in keeping with copyright law
    (e.g.: EITHER displayed when first invoked/executed; OR displayed
    continuously on display terminal; OR via placement in the  object
    code  in  form  readable in a printout, with or near the title of
    the work, or at the end of the file).  No royalties, licenses  or
    commissions  of  any  kind are required to copy this grammar, its
    translations, or derivative products, when the copies are made in
    compliance with this notice. Persons or corporations that do make
    copies in compliance with this notice may charge  whatever  price
    is  agreeable  to  a  buyer, for such copies or derivative works.
    THIS GRAMMAR IS PROVIDED ``AS IS'' AND  WITHOUT  ANY  EXPRESS  OR
    IMPLIED  WARRANTIES,  INCLUDING,  WITHOUT LIMITATION, THE IMPLIED
    WARRANTIES  OF  MERCHANTABILITY  AND  FITNESS  FOR  A  PARTICULAR
    PURPOSE.

    James A. Roskind
    Independent Consultant
    516 Latania Palm Drive
    Indialantic FL, 32903
    (407)729-4348
    jar@ileaf.com


    ---end of copyright notice---


This file is a companion file to a C++ grammar description file.

*/


/* FILENAME: C.Y */

/*  This  is a grammar file for the dpANSI C language.  This file was
last modified by J. Roskind on 3/7/90. Version 1.00 */




/* ACKNOWLEDGMENT:

Without the effort expended by the ANSI C standardizing committee,  I
would  have been lost.  Although the ANSI C standard does not include
a fully disambiguated syntax description, the committee has at  least
provided most of the disambiguating rules in narratives.

Several  reviewers  have also recently critiqued this grammar, and/or
assisted in discussions during it's preparation.  These reviewers are
certainly not responsible for the errors I have committed  here,  but
they  are responsible for allowing me to provide fewer errors.  These
colleagues include: Bruce Blodgett, and Mark Langley. */

#include "rename.h"
  

#ifdef flex
extern char * yytext;
#else
/* lex mylex */
extern char yytext[];
extern int yylex();
#endif

static char * stringliterallist;
#define AUTO 257
#define DOUBLE 258
#define INT 259
#define STRUCT 260
#define BREAK 261
#define ELSE 262
#define LONG 263
#define SWITCH 264
#define CASE 265
#define ENUM 266
#define REGISTER 267
#define TYPEDEF 268
#define CHAR 269
#define EXTERN 270
#define RETURN 271
#define UNION 272
#define CONST 273
#define FLOAT 274
#define SHORT 275
#define UNSIGNED 276
#define CONTINUE 277
#define FOR 278
#define SIGNED 279
#define VOID 280
#define DEFAULT 281
#define GOTO 282
#define SIZEOF 283
#define VOLATILE 284
#define DO 285
#define IF 286
#define STATIC 287
#define WHILE 288
#define IDENTIFIER 289
#define STRINGliteral 290
#define FLOATINGconstant 291
#define INTEGERconstant 292
#define CHARACTERconstant 293
#define OCTALconstant 294
#define HEXconstant 295
#define TYPEDEFname 296
#define ARROW 297
#define ICR 298
#define DECR 299
#define LS 300
#define RS 301
#define LE 302
#define GE 303
#define EQ 304
#define NE 305
#define ANDAND 306
#define OROR 307
#define ELLIPSIS 308
#define MULTassign 309
#define DIVassign 310
#define MODassign 311
#define PLUSassign 312
#define MINUSassign 313
#define LSassign 314
#define RSassign 315
#define ANDassign 316
#define ERassign 317
#define ORassign 318
#define SYNTAX_ERROR 319
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    1,    2,    2,    3,    3,    4,    4,    4,    4,    6,
    6,    6,    6,    6,    6,    7,   10,    7,    9,    9,
   11,   11,   11,   11,   11,   12,   12,   12,   12,   12,
   12,   13,   13,   15,   15,   15,   15,   16,   16,   16,
   17,   17,   17,   18,   18,   18,   18,   18,   19,   19,
   19,   20,   20,   21,   21,   22,   22,   23,   23,   24,
   24,   25,   25,    8,    8,   26,   27,   27,   27,   27,
   27,   27,   27,   27,   27,   27,   27,    5,    5,   28,
   28,   28,   29,   29,   30,   31,   32,   32,   33,   36,
   37,   37,   37,   38,   38,   39,   39,   40,   40,   40,
   43,   43,   14,   14,   35,   35,   45,   46,   44,   44,
   44,   48,   48,   48,   48,   47,   47,   49,   49,   49,
   49,   49,   49,   56,   50,   57,   50,   58,   51,   51,
   51,   51,   59,   59,   60,   60,   52,   53,   53,   53,
   54,   54,   54,   55,   55,   55,    0,    0,    0,    0,
   61,   61,   61,   61,   61,   61,   63,   63,   64,   65,
   66,   65,   34,   67,   42,   42,   68,   68,   71,   72,
   73,   74,   70,   70,   70,   69,   69,   62,   62,   77,
   76,   76,   76,   41,   41,   41,   75,   75,   81,   75,
   80,   80,   80,   78,   78,   79,   79,   79,   79,
};
short yylen[] = {                                         2,
    1,    1,    1,    1,    2,    1,    1,    1,    3,    1,
    4,    3,    2,    2,    2,    3,    0,    6,    1,    3,
    1,    2,    2,    2,    4,    1,    1,    1,    1,    1,
    1,    1,    4,    1,    3,    3,    3,    1,    3,    3,
    1,    3,    3,    1,    3,    3,    3,    3,    1,    3,
    3,    1,    3,    1,    3,    1,    3,    1,    3,    1,
    3,    1,    5,    1,    3,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    3,    1,
    2,    2,    0,    1,    1,    2,    3,    4,    1,    1,
    1,    1,    1,    1,    3,    1,    3,    1,    2,    2,
    1,    3,    1,    2,    0,    2,    1,    1,    3,    4,
    1,    3,    4,    1,    1,    1,    3,    1,    1,    1,
    1,    1,    1,    0,    5,    0,    4,    1,    2,    3,
    3,    4,    1,    2,    1,    2,    2,    5,    7,    5,
    5,    7,    9,    2,    2,    3,    1,    1,    1,    0,
    2,    3,    2,    3,    3,    4,    1,    2,    2,    2,
    0,    4,    1,    1,    1,    1,    1,    2,    1,    1,
    1,    1,    2,    3,    4,    1,    3,    1,    2,    0,
    5,    3,    4,    1,    1,    1,    1,    2,    0,    4,
    2,    3,    4,    1,    2,    3,    3,    3,    4,
};
short yydefred[] = {                                      0,
   91,   92,   93,    1,  169,  164,  128,    0,  176,  148,
    0,    0,   89,   90,    0,  149,    0,  147,    0,    0,
  165,    0,  167,    0,  178,   85,   86,    0,    0,    0,
    0,  151,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    4,    2,    3,    0,    0,    0,   26,
   27,   28,   29,   30,   31,  129,    6,    7,    0,   10,
    0,    0,   78,    0,    0,   34,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   64,    0,  133,    0,
  135,  118,  119,  120,  121,  122,  123,    0,    0,    0,
  153,    0,  157,    0,  168,  179,    0,    0,    0,  173,
    0,    0,    0,    0,    0,  163,    0,    0,    0,    0,
   87,  152,  154,    0,  145,    0,    0,    0,   80,    0,
    0,  144,    0,  126,    0,    0,    0,    0,    0,   22,
   23,    0,    0,    0,    5,    0,   14,   15,    0,    0,
   13,   68,   69,   70,   71,   72,   73,   74,   75,   76,
   77,   67,    0,   66,   32,   24,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  137,  130,  134,    0,  131,
  136,  160,  155,  158,  159,    0,    0,  191,    0,  171,
  188,    0,    0,    0,  182,    0,  174,    0,  177,   88,
    0,  107,  111,  106,    0,  156,    0,   81,   82,  124,
  146,    0,    0,    0,    0,    0,    0,    9,    0,  104,
    0,    0,  186,  184,  185,   79,   12,    0,    0,   65,
   35,   36,   37,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  132,
    0,  101,    0,  192,    0,    0,    0,   96,    0,  183,
  175,  115,  114,    0,    0,  116,    0,    0,    0,  127,
   25,    0,    0,    0,   33,  195,    0,    0,    0,   16,
   17,   11,    0,  162,  181,    0,   99,  100,    0,    0,
  190,    0,  193,    0,    0,  108,  109,  140,  125,    0,
    0,    0,  141,  198,    0,    0,  196,  197,    0,   63,
  102,   95,   97,    0,  112,  110,  117,    0,    0,    0,
  199,   19,    0,  113,    0,  142,  139,   18,    0,    0,
   20,  143,
};
short yydgoto[] = {                                       8,
   57,   58,   59,   60,   61,   62,  141,   63,  323,  309,
   64,   65,   66,  133,   67,   68,   69,   70,   71,   72,
   73,   74,   75,   76,   77,  153,  154,  263,   78,   28,
   10,   11,   90,   29,  111,   13,   14,  256,  257,  258,
  276,  106,  253,  204,  264,  297,  265,  266,   81,   82,
   83,   84,   85,   86,   87,  268,  213,   17,   88,   89,
   18,   19,   92,   93,   94,  186,  107,   21,  108,   23,
   99,  306,  191,  196,  100,   25,  187,  224,  225,  101,
  192,
};
short yysindex[] = {                                    604,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   64,  -33,    0,    0, -107,    0,  889,    0,  -72,  -33,
    0,   25,    0,  -33,    0,    0,    0,  -33,  -27, -107,
  -72,    0,  -16,   51,   30, 1272,   45,   87,   75,  154,
 1250,  177,  189,    0,    0,    0, 1283, 1283,  784,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -56,    0,
  202,  -25,    0,   61, 1272,    0,  400,  118, -254,  -22,
   48,  222,  176,  148,  -10,  -63,    0,  231,    0,  -33,
    0,    0,    0,    0,    0,    0,    0,  935, 1082,  -33,
    0,  -72,    0,  250,    0,    0,    0,   -6,  304,    0,
  227,  320,  320,  158,  -27,    0,  -33,  136,  -33, 1096,
    0,    0,    0,  -72,    0, 1272,   44,   74,    0,  335,
  346,    0, 1272,    0,  -50,  143, 1272, 1272, 1272,    0,
    0,  145,  397,  112,    0, 1272,    0,    0, 1261, 1272,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1272,    0,    0,    0, 1272, 1272, 1272, 1272,
 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272, 1272,
 1272, 1272, 1272, 1272, 1272,    0,    0,    0, 1208,    0,
    0,    0,    0,    0,    0,  423,  175,    0,  375,    0,
    0,  -50,   30,    0,    0,  136,    0,  136,    0,    0,
  164,    0,    0,    0,  420,    0,  172,    0,    0,    0,
    0,  412, 1250,  429,  433,  210,  344,    0, 1272,    0,
  112,  129,    0,    0,    0,    0,    0,  348,  103,    0,
    0,    0,    0,  400,  400,  118,  118, -254, -254, -254,
 -254,  -22,  -22,   48,  222,  176,  148,  -10,   12,    0,
  -33,    0,  379,    0,   60,  304,  435,    0,  396,    0,
    0,    0,    0,  420,  -41,    0, 1250, 1250, 1272,    0,
    0, 1272, 1250, 1250,    0,    0,  304,  441,  304,    0,
    0,    0, 1272,    0,    0,  175,    0,    0,   60,   27,
    0,  -58,    0,   52,   58,    0,    0,    0,    0,  436,
  389,  230,    0,    0,    0,  136,    0,    0, 1272,    0,
    0,    0,    0,   58,    0,    0,    0, 1272,  437, 1250,
    0,    0,  411,    0,  453,    0,    0,    0, 1272, 1250,
    0,    0,
};
short yyrindex[] = {                                    498,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  438,    0,    0,    0,
    0,  105,    0,    0,    0,    0,    0,    0,  181,  218,
    0,    0,    0,    0,    0,  438,    0,    0,    0,    0,
  438,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   97,    0,
  151,  270,    0,  297,    0,    0,  324,  418,  472,  750,
  812,  121,  966,   13,   36,  497,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  438,  438,    0,
    0,    0,    0,  455,    0,    0,  -28,    0,  -11,    0,
  224,    0,    0,    0,  181,    0,    0,  223,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  438,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  459,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  438,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1278,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  438,    0,    0,    0,    0,    0,    0,    0,
  320,  -11,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  381,  391,  428,  465,  575,  612,  699,
  742,  774,  801,  845,  903, 1105,   20,  109,    0,    0,
    0,    0,    0,    0,  416,    0,  460,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  438,  438,  438,    0,
    0,    0,  438,  438,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  417,  -11,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  978,    0,    0,   19,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  461,    0,  438,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  438,
    0,    0,
};
short yygindex[] = {                                      0,
    8,    7,    0,    0,    3,    0,    0,  -91,    0,    0,
 1427,    0,   16,  382,  220,  162,  139,  277,  338,  343,
  345,  347,  352,    0,  236,    0,    0,   -8,  -30,  350,
   32,    0,    1,   -4,  424,    0,    0,    0,    0,  247,
 -130,   21,    0,    0,  430,  -88,  280, -240,  -31,    0,
  518,    0,    0,    0,    0,    0,    0,    0,    0,  457,
    0,  334,  515,   -7,    0,    0,   11,  -12,    5,    0,
    2,    0,  613,  444,  762,    0,    0, -178, -169,    0,
    0,
};
#define YYTABLESIZE 1710
short yytable[] = {                                     175,
   12,   24,  295,  220,   22,  121,    5,    9,    6,  126,
   20,  103,  169,   24,  139,    7,   22,   80,  203,    9,
   15,   24,   20,  105,   22,   24,  120,    9,  104,  109,
   20,    9,   30,  110,   20,    9,  117,  166,  118,  167,
   95,  119,  115,  278,  226,  162,  163,  228,   79,  134,
    7,  132,  279,   58,  317,  136,   58,  181,  170,  171,
   59,  230,  171,   59,   97,  140,    5,  190,    6,  283,
   58,   58,  117,  317,  118,   58,   60,   59,   59,   60,
  156,  109,   59,  296,  184,  182,  188,    9,   80,  189,
  116,  109,  212,   60,   60,  314,  103,    9,   60,    5,
  117,    6,  118,  122,  119,   58,  184,   26,  109,  170,
  109,  278,   59,  201,    9,   98,    9,   98,  207,  178,
  279,  152,   27,  208,  287,  134,  123,   95,   60,  216,
  217,  132,  124,    8,    8,  222,    8,    8,    8,    8,
    8,    8,  229,    8,  221,  166,  136,  181,  166,   61,
   98,    5,   61,    6,    8,    8,    8,    8,    8,    8,
  160,   54,  161,  166,   54,  166,   61,   61,    5,  190,
    6,   61,  231,  232,  233,    5,  296,  249,   54,   54,
  202,  270,  296,   54,  259,  218,    1,    8,  136,    8,
    8,   84,  255,  125,  252,  282,    2,   97,  190,  119,
    1,   61,   98,    5,  190,  315,  316,    3,    1,   84,
    2,  119,  267,   54,   54,  136,  127,  322,    2,   98,
    8,    3,  222,  222,  105,  324,   98,  166,  128,    3,
  169,  221,  221,  135,  275,  298,  299,  331,  300,  105,
  169,  302,  303,  174,   54,  136,  284,  189,   98,  312,
  273,  169,  109,  136,   98,    4,  290,  189,    9,  170,
  180,  163,    9,  166,  187,  289,  166,  187,  189,  171,
  119,  172,  137,  138,  301,  288,  163,  103,  163,  164,
  165,  166,  187,  166,  187,   45,   46,  325,  327,  176,
  290,  290,  255,  311,  201,  173,    9,    9,  332,  289,
  289,  119,  238,  239,  240,  241,   21,   21,  185,   95,
   21,   21,   21,   21,   21,    4,   21,  193,   58,   58,
  119,   45,   46,  236,  237,   59,   59,   21,   21,   21,
   21,   21,   21,   32,   32,   45,   46,   32,   32,   32,
   32,   32,   60,   32,  190,   31,  187,  262,    4,   45,
   46,  168,  169,   96,   32,   32,   32,  102,   32,   32,
  194,   38,   21,   21,   38,  209,   38,   38,   38,  142,
  143,  144,  145,  146,  147,  148,  149,  150,  151,  234,
  235,   38,   38,   38,  274,   38,   38,  136,  280,   32,
   32,  281,  210,   21,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,  211,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,   61,   38,   38,   39,  285,
   32,   39,  286,   39,   39,   39,   54,   54,   40,  319,
  215,   40,  136,   40,   40,   40,  159,  219,   39,   39,
   39,  157,   39,   39,  242,  243,  158,   38,   40,   40,
   40,  328,   40,   40,  329,   41,   98,  194,   41,   98,
  194,   41,  117,    4,  118,   42,   26,  254,   42,  271,
  269,   42,  272,   39,   39,   41,   41,   41,  292,   41,
   41,  305,  187,   40,   40,   42,   42,   42,  293,   42,
   42,  320,  187,  330,  318,  326,   83,  150,  161,  103,
   94,   83,   43,  187,   39,   43,  214,  244,   43,   44,
   41,   41,   44,  245,   40,   44,  246,   16,  310,  247,
   42,   42,   43,   43,   43,  248,   43,   43,  200,   44,
   44,   44,   32,   44,   44,  251,   91,   62,  313,  205,
   62,   41,  202,  294,  179,  114,  198,  112,  113,    0,
    0,   42,    0,    0,   62,   62,    0,   43,   43,    0,
    0,    0,    0,    0,   44,   44,    0,    0,    0,   21,
   21,   21,   21,   21,   21,   21,   21,    0,   21,   21,
   21,   21,   21,   21,   21,   21,   21,   21,   43,   62,
    0,    0,    0,    0,    0,   44,   32,   32,   32,   32,
   32,   32,   32,   32,    0,    0,    0,    0,    0,  183,
    0,    0,   47,    0,    0,   47,    0,    0,   47,    0,
    0,    0,    0,   38,   38,   38,   38,   38,   38,   38,
   38,  206,   47,   47,   47,    0,   47,   47,    0,    0,
    0,    0,    0,    5,    0,    6,    0,    0,    0,   48,
    0,    0,   48,    0,    0,   48,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   47,   47,   48,
   48,   48,    0,   48,   48,    0,    0,    0,    0,    0,
   39,   39,   39,   39,   39,   39,   39,   39,    0,    0,
   40,   40,   40,   40,   40,   40,   40,   40,   47,    0,
    0,    0,    0,    0,   48,   48,    0,    0,    0,  262,
    0,   45,   46,    0,  195,  197,  199,   41,   41,   41,
   41,   41,   41,   41,   41,    0,    7,   42,   42,   42,
   42,   42,   42,   42,   42,   48,   45,    0,    0,   45,
    0,    0,   45,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   45,   45,   45,    0,
   45,   45,    0,    0,   43,   43,   43,   43,   43,   43,
   43,   43,    0,   44,   44,   44,   44,   44,   44,   46,
    0,    0,   46,    0,    0,   46,    0,   49,    0,    0,
   49,   45,   45,   49,    0,    0,    0,    0,    0,   46,
   46,   46,    0,   46,   46,    0,    0,   49,   49,    0,
    0,   50,   49,  199,   50,    0,   55,   50,    0,    0,
    0,   50,   45,   49,    0,   51,   52,    0,   53,    0,
    0,   50,   50,    0,   46,   46,   50,    0,   51,    0,
    0,   51,   49,   49,   51,    0,    0,    0,    0,   52,
    0,    0,   52,    0,    0,   52,    0,    0,   51,   51,
    0,    0,    1,   51,    0,   46,   50,   50,  291,   52,
   52,    0,    2,   49,   52,    0,   47,   47,   47,   47,
   47,   47,   53,    3,    0,   53,    0,    0,   53,  304,
  307,  308,    4,   51,   51,  223,    0,   50,    0,    0,
    0,    0,   53,   53,   52,   52,    0,   53,    0,   54,
    0,    0,    0,   48,   48,   48,   48,   48,   48,    0,
    0,   55,    0,    0,   51,    0,   50,    0,   49,    0,
   51,   52,    0,   53,    0,   52,    0,   53,   53,    0,
    0,    0,    0,   55,    0,    0,   55,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  260,    0,  261,
   55,   55,    0,    0,    0,   55,    0,   55,   53,    0,
    0,    0,   50,    0,   49,    0,   51,   52,    0,   53,
    0,    0,  223,  277,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   55,   55,    0,    0,    0,
   45,   45,   45,   45,   45,   45,   56,    0,    0,   56,
  138,    7,    0,   56,   54,  138,  223,  138,    0,  138,
  138,    0,  138,   56,   56,    0,   55,    0,   56,    0,
    0,    0,    0,    0,    0,    0,  138,    0,    0,    0,
    0,    0,    1,   46,   46,   46,   46,   46,   46,    0,
  223,  277,    2,   49,   49,   49,   49,    7,   56,  177,
   54,    0,    0,    3,    0,    0,   40,  321,    0,    0,
    0,    0,    4,   44,    0,   45,   46,   50,   50,   50,
   50,   47,   48,    0,    0,    0,    0,    0,    0,   56,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  138,    0,  138,  138,   51,   51,   51,   51,    0,    0,
    0,    0,    0,    0,   55,    0,    0,   52,   52,   50,
    0,   49,    0,   51,   52,    0,   53,    0,   55,    0,
    0,    0,    0,   50,    0,   49,    0,   51,   52,    0,
   53,    0,    0,    0,    0,   57,    0,    1,   57,   33,
   53,   53,   34,   35,    0,    0,    0,    2,    0,   36,
    0,    0,   57,   57,    0,   37,   38,   57,    3,   39,
    0,   40,    0,   41,   42,    0,   43,    4,   44,    0,
   45,   46,    0,    0,    0,    0,   47,   48,    0,    0,
    0,    0,    0,    1,    0,   33,    0,   57,   34,   35,
    0,    0,    0,    2,    7,   36,  180,   54,   55,   55,
    0,   37,   38,    0,    3,   39,    0,   40,  202,   41,
   42,   54,   43,    4,   44,    0,   45,   46,   57,    0,
    0,    0,   47,   48,    0,    0,    0,    0,  138,    0,
   55,  138,  138,    0,    0,   50,    0,   49,  138,   51,
   52,    0,   53,    0,  138,  138,    0,    0,  138,    0,
  138,    0,  138,  138,    0,  138,  138,  138,    0,  138,
  138,   56,   56,    0,    0,  138,  138,    0,    0,    0,
    0,    0,   55,    0,    0,    0,    0,   50,    0,   49,
    0,   51,   52,   55,   53,    0,    0,    0,   50,    0,
   49,  227,   51,   52,   55,   53,    0,    0,    0,   50,
    0,   49,    0,   51,   52,   55,   53,  172,  171,    0,
   50,  171,  129,    0,   51,   52,    0,   53,    0,    0,
    7,    0,  250,   54,    0,    0,  171,    0,  171,    0,
    0,    0,   33,    0,    0,   34,   35,    0,    0,    0,
    0,    0,   36,    0,    0,    0,    0,    0,   37,   38,
    0,    0,   39,    0,   40,    0,   41,   42,  172,   43,
    4,   44,    7,   45,   46,   54,    0,    0,   40,   47,
   48,    0,    0,    0,    4,   44,   54,   45,   46,    0,
    0,    0,    0,   47,   48,    0,    0,   54,    0,    0,
  171,    0,    0,    0,    0,    0,    0,    0,   54,    0,
   57,   57,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   33,    0,
    0,   34,   35,  130,  131,    0,    0,    0,   36,    0,
    0,    0,    0,    0,   37,   38,    0,    0,   39,    0,
   40,  155,   41,   42,    0,   43,    4,   44,    0,   45,
   46,    0,    0,    0,    0,   47,   48,    0,    0,    0,
   33,    0,    0,   34,   35,    0,    0,    0,    0,    0,
   36,    0,    0,    0,    0,    0,   37,   38,    0,    0,
   39,    0,   40,    0,   41,   42,  171,   43,    4,   44,
    0,   45,   46,   40,    0,    0,  171,   47,   48,    4,
   44,    0,   45,   46,   40,    0,    0,  171,   47,   48,
    4,   44,    0,   45,   46,   40,    0,    0,    0,   47,
   48,    4,   44,    0,   45,   46,    0,    0,    0,    0,
   47,   48,    0,  155,  155,  155,  155,  155,  155,  155,
  155,  155,  155,  155,  155,  155,  155,  155,  155,  155,
  155,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  155,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  155,
};
short yycheck[] = {                                      63,
    0,    0,   44,  134,    0,   36,   40,    0,   42,   41,
    0,   24,   41,   12,   40,  123,   12,   17,  110,   12,
    0,   20,   12,   28,   20,   24,   35,   20,   24,   28,
   20,   24,   12,   61,   24,   28,   43,   60,   45,   62,
   20,   35,   59,  222,  136,  300,  301,  139,   17,   49,
  123,   49,  222,   41,  295,   44,   44,   89,   40,   41,
   41,  153,   44,   44,   40,   91,   40,   41,   42,   58,
   58,   59,   43,  314,   45,   63,   41,   58,   59,   44,
   65,   80,   63,  125,   92,   90,   93,   80,   88,   98,
   40,   90,  123,   58,   59,   44,  109,   90,   63,   40,
   43,   42,   45,   59,   98,   93,  114,   44,  107,   91,
  109,  290,   93,  109,  107,   91,  109,   91,  116,   88,
  290,   61,   59,  117,  255,  125,   40,  107,   93,  127,
  128,  129,   58,   37,   38,  134,   40,   41,   42,   43,
   44,   45,  140,   47,  134,   41,   44,  179,   44,   41,
   91,   40,   44,   42,   58,   59,   60,   61,   62,   63,
   43,   41,   45,   59,   44,   61,   58,   59,   40,   41,
   42,   63,  157,  158,  159,   40,  125,  175,   58,   59,
  123,  213,  125,   63,  193,   41,  259,   91,   44,   93,
   94,   41,  192,   40,  187,   93,  269,   40,   41,  193,
  259,   93,   91,   40,   41,  294,  295,  280,  259,   59,
  269,  205,   41,   93,   94,   44,   40,  309,  269,   91,
  124,  280,  221,  222,   44,  314,   91,  123,   40,  280,
  259,  221,  222,  290,  219,  267,  268,  329,  269,   59,
  269,  273,  274,  307,  124,   44,  251,  259,   91,  308,
   41,  280,  251,   44,   91,  289,  255,  269,  251,   38,
  289,   44,  255,   41,   41,  255,   44,   44,  280,   94,
  264,  124,  298,  299,  272,  255,   59,  290,   61,  302,
  303,   59,   59,   61,   61,  292,  293,  318,  320,   59,
  289,  290,  292,  286,  290,  306,  289,  290,  330,  289,
  290,  295,  164,  165,  166,  167,   37,   38,   59,  289,
   41,   42,   43,   44,   45,  289,   47,   91,  306,  307,
  314,  292,  293,  162,  163,  306,  307,   58,   59,   60,
   61,   62,   63,   37,   38,  292,  293,   41,   42,   43,
   44,   45,  307,   47,   41,   12,  123,  290,  289,  292,
  293,  304,  305,   20,   58,   59,   60,   24,   62,   63,
   41,   38,   93,   94,   41,  292,   43,   44,   45,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,  160,
  161,   58,   59,   60,   41,   62,   63,   44,   41,   93,
   94,   44,   58,  124,  298,  299,  300,  301,  302,  303,
  304,  305,  306,  307,   59,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  307,   93,   94,   38,   41,
  124,   41,   44,   43,   44,   45,  306,  307,   38,   41,
  288,   41,   44,   43,   44,   45,   37,   41,   58,   59,
   60,   42,   62,   63,  168,  169,   47,  124,   58,   59,
   60,   41,   62,   63,   44,   38,   41,   41,   41,   44,
   44,   44,   43,  289,   45,   38,   44,   93,   41,   41,
   59,   44,   40,   93,   94,   58,   59,   60,   44,   62,
   63,   41,  259,   93,   94,   58,   59,   60,   93,   62,
   63,  262,  269,   41,   59,   59,   59,    0,   44,   41,
   41,   41,   38,  280,  124,   41,  125,  170,   44,   38,
   93,   94,   41,  171,  124,   44,  172,    0,  283,  173,
   93,   94,   58,   59,   60,  174,   62,   63,  105,   58,
   59,   60,   15,   62,   63,  186,   19,   41,  292,  110,
   44,  124,  123,  264,   88,   31,  103,   30,   31,   -1,
   -1,  124,   -1,   -1,   58,   59,   -1,   93,   94,   -1,
   -1,   -1,   -1,   -1,   93,   94,   -1,   -1,   -1,  300,
  301,  302,  303,  304,  305,  306,  307,   -1,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,  124,   93,
   -1,   -1,   -1,   -1,   -1,  124,  300,  301,  302,  303,
  304,  305,  306,  307,   -1,   -1,   -1,   -1,   -1,   92,
   -1,   -1,   38,   -1,   -1,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,  300,  301,  302,  303,  304,  305,  306,
  307,  114,   58,   59,   60,   -1,   62,   63,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   42,   -1,   -1,   -1,   38,
   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   94,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   -1,   -1,   -1,
  300,  301,  302,  303,  304,  305,  306,  307,   -1,   -1,
  300,  301,  302,  303,  304,  305,  306,  307,  124,   -1,
   -1,   -1,   -1,   -1,   93,   94,   -1,   -1,   -1,  290,
   -1,  292,  293,   -1,  102,  103,  104,  300,  301,  302,
  303,  304,  305,  306,  307,   -1,  123,  300,  301,  302,
  303,  304,  305,  306,  307,  124,   38,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   -1,
   62,   63,   -1,   -1,  300,  301,  302,  303,  304,  305,
  306,  307,   -1,  302,  303,  304,  305,  306,  307,   38,
   -1,   -1,   41,   -1,   -1,   44,   -1,   38,   -1,   -1,
   41,   93,   94,   44,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   -1,   62,   63,   -1,   -1,   58,   59,   -1,
   -1,   38,   63,  201,   41,   -1,   33,   44,   -1,   -1,
   -1,   38,  124,   40,   -1,   42,   43,   -1,   45,   -1,
   -1,   58,   59,   -1,   93,   94,   63,   -1,   38,   -1,
   -1,   41,   93,   94,   44,   -1,   -1,   -1,   -1,   38,
   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   58,   59,
   -1,   -1,  259,   63,   -1,  124,   93,   94,  256,   58,
   59,   -1,  269,  124,   63,   -1,  302,  303,  304,  305,
  306,  307,   38,  280,   -1,   41,   -1,   -1,   44,  277,
  278,  279,  289,   93,   94,  134,   -1,  124,   -1,   -1,
   -1,   -1,   58,   59,   93,   94,   -1,   63,   -1,  126,
   -1,   -1,   -1,  302,  303,  304,  305,  306,  307,   -1,
   -1,   33,   -1,   -1,  124,   -1,   38,   -1,   40,   -1,
   42,   43,   -1,   45,   -1,  124,   -1,   93,   94,   -1,
   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  196,   -1,  198,
   58,   59,   -1,   -1,   -1,   63,   -1,   33,  124,   -1,
   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,
   -1,   -1,  221,  222,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   94,   -1,   -1,   -1,
  302,  303,  304,  305,  306,  307,   41,   -1,   -1,   44,
   33,  123,   -1,  125,  126,   38,  255,   40,   -1,   42,
   43,   -1,   45,   58,   59,   -1,  124,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,   -1,   -1,
   -1,   -1,  259,  302,  303,  304,  305,  306,  307,   -1,
  289,  290,  269,  304,  305,  306,  307,  123,   93,  125,
  126,   -1,   -1,  280,   -1,   -1,  283,  306,   -1,   -1,
   -1,   -1,  289,  290,   -1,  292,  293,  304,  305,  306,
  307,  298,  299,   -1,   -1,   -1,   -1,   -1,   -1,  124,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  123,   -1,  125,  126,  304,  305,  306,  307,   -1,   -1,
   -1,   -1,   -1,   -1,   33,   -1,   -1,  306,  307,   38,
   -1,   40,   -1,   42,   43,   -1,   45,   -1,   33,   -1,
   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,
   45,   -1,   -1,   -1,   -1,   41,   -1,  259,   44,  261,
  306,  307,  264,  265,   -1,   -1,   -1,  269,   -1,  271,
   -1,   -1,   58,   59,   -1,  277,  278,   63,  280,  281,
   -1,  283,   -1,  285,  286,   -1,  288,  289,  290,   -1,
  292,  293,   -1,   -1,   -1,   -1,  298,  299,   -1,   -1,
   -1,   -1,   -1,  259,   -1,  261,   -1,   93,  264,  265,
   -1,   -1,   -1,  269,  123,  271,  125,  126,  306,  307,
   -1,  277,  278,   -1,  280,  281,   -1,  283,  123,  285,
  286,  126,  288,  289,  290,   -1,  292,  293,  124,   -1,
   -1,   -1,  298,  299,   -1,   -1,   -1,   -1,  261,   -1,
   33,  264,  265,   -1,   -1,   38,   -1,   40,  271,   42,
   43,   -1,   45,   -1,  277,  278,   -1,   -1,  281,   -1,
  283,   -1,  285,  286,   -1,  288,  289,  290,   -1,  292,
  293,  306,  307,   -1,   -1,  298,  299,   -1,   -1,   -1,
   -1,   -1,   33,   -1,   -1,   -1,   -1,   38,   -1,   40,
   -1,   42,   43,   33,   45,   -1,   -1,   -1,   38,   -1,
   40,   41,   42,   43,   33,   45,   -1,   -1,   -1,   38,
   -1,   40,   -1,   42,   43,   33,   45,   40,   41,   -1,
   38,   44,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
  123,   -1,  125,  126,   -1,   -1,   59,   -1,   61,   -1,
   -1,   -1,  261,   -1,   -1,  264,  265,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,  278,
   -1,   -1,  281,   -1,  283,   -1,  285,  286,   91,  288,
  289,  290,  123,  292,  293,  126,   -1,   -1,  283,  298,
  299,   -1,   -1,   -1,  289,  290,  126,  292,  293,   -1,
   -1,   -1,   -1,  298,  299,   -1,   -1,  126,   -1,   -1,
  123,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,
  306,  307,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  261,   -1,
   -1,  264,  265,   47,   48,   -1,   -1,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,  278,   -1,   -1,  281,   -1,
  283,   65,  285,  286,   -1,  288,  289,  290,   -1,  292,
  293,   -1,   -1,   -1,   -1,  298,  299,   -1,   -1,   -1,
  261,   -1,   -1,  264,  265,   -1,   -1,   -1,   -1,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,  278,   -1,   -1,
  281,   -1,  283,   -1,  285,  286,  259,  288,  289,  290,
   -1,  292,  293,  283,   -1,   -1,  269,  298,  299,  289,
  290,   -1,  292,  293,  283,   -1,   -1,  280,  298,  299,
  289,  290,   -1,  292,  293,  283,   -1,   -1,   -1,  298,
  299,  289,  290,   -1,  292,  293,   -1,   -1,   -1,   -1,
  298,  299,   -1,  157,  158,  159,  160,  161,  162,  163,
  164,  165,  166,  167,  168,  169,  170,  171,  172,  173,
  174,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  219,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  283,
};
#define YYFINAL 8
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 319
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'",0,"'/'",0,0,0,0,0,
0,0,0,0,0,"':'","';'","'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"AUTO","DOUBLE",
"INT","STRUCT","BREAK","ELSE","LONG","SWITCH","CASE","ENUM","REGISTER",
"TYPEDEF","CHAR","EXTERN","RETURN","UNION","CONST","FLOAT","SHORT","UNSIGNED",
"CONTINUE","FOR","SIGNED","VOID","DEFAULT","GOTO","SIZEOF","VOLATILE","DO","IF",
"STATIC","WHILE","IDENTIFIER","STRINGliteral","FLOATINGconstant",
"INTEGERconstant","CHARACTERconstant","OCTALconstant","HEXconstant",
"TYPEDEFname","ARROW","ICR","DECR","LS","RS","LE","GE","EQ","NE","ANDAND",
"OROR","ELLIPSIS","MULTassign","DIVassign","MODassign","PLUSassign",
"MINUSassign","LSassign","RSassign","ANDassign","ERassign","ORassign",
"SYNTAX_ERROR",
};
char *yyrule[] = {
"$accept : external_definition",
"_IDENTIFIER : IDENTIFIER",
"constant : INTEGERconstant",
"constant : CHARACTERconstant",
"string_literal_list : STRINGliteral",
"string_literal_list : string_literal_list STRINGliteral",
"primary_expression : _IDENTIFIER",
"primary_expression : constant",
"primary_expression : string_literal_list",
"primary_expression : '(' comma_expression ')'",
"postfix_expression : primary_expression",
"postfix_expression : postfix_expression '[' comma_expression ']'",
"postfix_expression : postfix_expression '(' ')'",
"postfix_expression : postfix_expression _argument_expression_list",
"postfix_expression : postfix_expression ICR",
"postfix_expression : postfix_expression DECR",
"_argument_expression_list : '(' assignment_expression ')'",
"$$1 :",
"_argument_expression_list : '(' assignment_expression ',' $$1 argument_expression_list ')'",
"argument_expression_list : assignment_expression",
"argument_expression_list : argument_expression_list ',' assignment_expression",
"unary_expression : postfix_expression",
"unary_expression : ICR unary_expression",
"unary_expression : DECR unary_expression",
"unary_expression : unary_operator cast_expression",
"unary_expression : SIZEOF '(' type_name ')'",
"unary_operator : '&'",
"unary_operator : '*'",
"unary_operator : '+'",
"unary_operator : '-'",
"unary_operator : '~'",
"unary_operator : '!'",
"cast_expression : unary_expression",
"cast_expression : '(' type_name ')' cast_expression",
"multiplicative_expression : cast_expression",
"multiplicative_expression : multiplicative_expression '*' cast_expression",
"multiplicative_expression : multiplicative_expression '/' cast_expression",
"multiplicative_expression : multiplicative_expression '%' cast_expression",
"additive_expression : multiplicative_expression",
"additive_expression : additive_expression '+' multiplicative_expression",
"additive_expression : additive_expression '-' multiplicative_expression",
"shift_expression : additive_expression",
"shift_expression : shift_expression LS additive_expression",
"shift_expression : shift_expression RS additive_expression",
"relational_expression : shift_expression",
"relational_expression : relational_expression '<' shift_expression",
"relational_expression : relational_expression '>' shift_expression",
"relational_expression : relational_expression LE shift_expression",
"relational_expression : relational_expression GE shift_expression",
"equality_expression : relational_expression",
"equality_expression : equality_expression EQ relational_expression",
"equality_expression : equality_expression NE relational_expression",
"AND_expression : equality_expression",
"AND_expression : AND_expression '&' equality_expression",
"exclusive_OR_expression : AND_expression",
"exclusive_OR_expression : exclusive_OR_expression '^' AND_expression",
"inclusive_OR_expression : exclusive_OR_expression",
"inclusive_OR_expression : inclusive_OR_expression '|' exclusive_OR_expression",
"logical_AND_expression : inclusive_OR_expression",
"logical_AND_expression : logical_AND_expression ANDAND inclusive_OR_expression",
"logical_OR_expression : logical_AND_expression",
"logical_OR_expression : logical_OR_expression OROR logical_AND_expression",
"conditional_expression : logical_OR_expression",
"conditional_expression : logical_OR_expression '?' comma_expression ':' conditional_expression",
"assignment_expression : conditional_expression",
"assignment_expression : unary_expression _assignment_operator assignment_expression",
"_assignment_operator : assignment_operator",
"assignment_operator : '='",
"assignment_operator : MULTassign",
"assignment_operator : DIVassign",
"assignment_operator : MODassign",
"assignment_operator : PLUSassign",
"assignment_operator : MINUSassign",
"assignment_operator : LSassign",
"assignment_operator : RSassign",
"assignment_operator : ANDassign",
"assignment_operator : ERassign",
"assignment_operator : ORassign",
"comma_expression : assignment_expression",
"comma_expression : comma_expression ',' assignment_expression",
"constant_expression : constant",
"constant_expression : '+' constant",
"constant_expression : '-' INTEGERconstant",
"comma_expression_opt :",
"comma_expression_opt : comma_expression",
"decl_comma : ','",
"declaration : declaring_list ';'",
"declaring_list : type_specifier declarator initializer_opt",
"declaring_list : declaring_list decl_comma declarator initializer_opt",
"type_specifier : basic_type_specifier",
"basic_type_specifier : _basic_type_name",
"_basic_type_name : INT",
"_basic_type_name : CHAR",
"_basic_type_name : VOID",
"parameter_type_list : parameter_list",
"parameter_type_list : parameter_list ',' ELLIPSIS",
"parameter_list : parameter_declaration",
"parameter_list : parameter_list ',' parameter_declaration",
"parameter_declaration : type_specifier",
"parameter_declaration : type_specifier abstract_declarator",
"parameter_declaration : type_specifier identifier_declarator",
"identifier_list : _IDENTIFIER",
"identifier_list : identifier_list ',' _IDENTIFIER",
"type_name : type_specifier",
"type_name : type_specifier abstract_declarator",
"initializer_opt :",
"initializer_opt : '=' initializer",
"begin_initializer_list : '{'",
"end_initializer_list : '}'",
"initializer : begin_initializer_list initializer_list end_initializer_list",
"initializer : begin_initializer_list initializer_list ',' end_initializer_list",
"initializer : assignment_expression",
"initializer_item : begin_initializer_list initializer_list end_initializer_list",
"initializer_item : begin_initializer_list initializer_list ',' end_initializer_list",
"initializer_item : constant_expression",
"initializer_item : STRINGliteral",
"initializer_list : initializer_item",
"initializer_list : initializer_list ',' initializer_item",
"statement : labeled_statement",
"statement : compound_statement",
"statement : expression_statement",
"statement : selection_statement",
"statement : iteration_statement",
"statement : jump_statement",
"$$2 :",
"labeled_statement : CASE constant_expression ':' $$2 statement",
"$$3 :",
"labeled_statement : DEFAULT ':' $$3 statement",
"begin_compound_statement : '{'",
"compound_statement : begin_compound_statement '}'",
"compound_statement : begin_compound_statement declaration_list '}'",
"compound_statement : begin_compound_statement statement_list '}'",
"compound_statement : begin_compound_statement declaration_list statement_list '}'",
"declaration_list : declaration",
"declaration_list : declaration_list declaration",
"statement_list : statement",
"statement_list : statement_list statement",
"expression_statement : comma_expression_opt ';'",
"selection_statement : IF '(' comma_expression ')' statement",
"selection_statement : IF '(' comma_expression ')' statement ELSE statement",
"selection_statement : SWITCH '(' comma_expression ')' statement",
"iteration_statement : WHILE '(' comma_expression ')' statement",
"iteration_statement : DO statement WHILE '(' comma_expression ')' ';'",
"iteration_statement : FOR '(' comma_expression_opt ';' comma_expression_opt ';' comma_expression_opt ')' statement",
"jump_statement : CONTINUE ';'",
"jump_statement : BREAK ';'",
"jump_statement : RETURN comma_expression_opt ';'",
"external_definition : function_definition",
"external_definition : declaration",
"external_definition : compound_statement",
"external_definition :",
"function_definition : identifier_declarator compound_statement",
"function_definition : type_specifier identifier_declarator compound_statement",
"function_definition : old_function_declarator compound_statement",
"function_definition : type_specifier old_function_declarator compound_statement",
"function_definition : old_function_declarator old_declaration_list compound_statement",
"function_definition : type_specifier old_function_declarator old_declaration_list compound_statement",
"old_declaration_list : old_declaration",
"old_declaration_list : old_declaration_list old_declaration",
"old_declaration : old_declaring_list ';'",
"old_declaring_list : type_specifier declarator",
"$$4 :",
"old_declaring_list : old_declaring_list $$4 decl_comma declarator",
"declarator : identifier_declarator",
"asterisk : '*'",
"identifier_declarator : unary_identifier_declarator",
"identifier_declarator : paren_identifier_declarator",
"unary_identifier_declarator : postfix_identifier_declarator",
"unary_identifier_declarator : asterisk identifier_declarator",
"begin_of_list : '('",
"end_of_list : ')'",
"forget_list : ')'",
"forget_list_if_possible : ')'",
"postfix_identifier_declarator : paren_identifier_declarator postfixing_abstract_declarator",
"postfix_identifier_declarator : begin_of_list unary_identifier_declarator forget_list",
"postfix_identifier_declarator : begin_of_list unary_identifier_declarator forget_list_if_possible postfixing_abstract_declarator",
"paren_identifier_declarator : _IDENTIFIER",
"paren_identifier_declarator : begin_of_list paren_identifier_declarator forget_list",
"old_function_declarator : postfix_old_function_declarator",
"old_function_declarator : asterisk old_function_declarator",
"$$5 :",
"postfix_old_function_declarator : paren_identifier_declarator '(' $$5 identifier_list ')'",
"postfix_old_function_declarator : begin_of_list old_function_declarator forget_list",
"postfix_old_function_declarator : begin_of_list old_function_declarator forget_list_if_possible postfixing_abstract_declarator",
"abstract_declarator : unary_abstract_declarator",
"abstract_declarator : postfix_abstract_declarator",
"abstract_declarator : postfixing_abstract_declarator",
"postfixing_abstract_declarator : array_abstract_declarator",
"postfixing_abstract_declarator : begin_of_list forget_list",
"$$6 :",
"postfixing_abstract_declarator : begin_of_list $$6 parameter_type_list forget_list",
"array_abstract_declarator : '[' ']'",
"array_abstract_declarator : '[' constant_expression ']'",
"array_abstract_declarator : array_abstract_declarator '[' constant_expression ']'",
"unary_abstract_declarator : asterisk",
"unary_abstract_declarator : asterisk abstract_declarator",
"postfix_abstract_declarator : begin_of_list unary_abstract_declarator forget_list",
"postfix_abstract_declarator : begin_of_list postfix_abstract_declarator forget_list",
"postfix_abstract_declarator : begin_of_list postfixing_abstract_declarator forget_list",
"postfix_abstract_declarator : begin_of_list unary_abstract_declarator end_of_list postfixing_abstract_declarator",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
/* ----end of grammar----*/

#include <stdio.h>

#include "decl.h"

int numlig;
char * yyinfilename = 0;
extern char err_msg[];

void yyerror(string)
     char *string;
{
  /* Attention, la forme du message est connue dans smacXcoral,c */

  if (! *err_msg) {
    /* Pas une erreur (f)lex */
    if (yyinfilename)
      sprintf(err_msg, "parser error in %s line %d : %s",
	      yyinfilename, numlig + 1, string);
    else
      sprintf(err_msg, "parser error line %d : %s", numlig, string);
  }
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
#if defined(__STDC__)
yyparse(void)
#else
yyparse()
#endif
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
{ memo_identifier(yytext); }
break;
case 2:
{ memo_integer(yytext); }
break;
case 3:
{ memo_char(yytext); }
break;
case 4:
{ stringliterallist = Strdup(yytext); }
break;
case 5:
{ 
		  char * s = Malloc(strlen(stringliterallist) +
				    strlen(yytext) - 1);
		  
		  strcpy(s, stringliterallist);
		  strcpy(s + strlen(s) - 1, yytext + 1);
		  
		  free(stringliterallist);
		  stringliterallist = s;
		}
break;
case 8:
{ memo_string(stringliterallist); free(stringliterallist); }
break;
case 11:
{ memo_array_access(); }
break;
case 12:
{ memo_funcall_0_arg(); }
break;
case 13:
{ memo_funcall_nargs(); }
break;
case 14:
{ memo_post_incr(); }
break;
case 15:
{ memo_post_decr(); }
break;
case 16:
{ mark_one_arg(); }
break;
case 17:
{ mark_first_arg(); }
break;
case 18:
{ mark_some_args(); }
break;
case 22:
{ memo_pre_incr(); }
break;
case 23:
{ memo_pre_decr(); }
break;
case 24:
{ memo_unary_oper(); }
break;
case 25:
{ memo_sizeof_type();}
break;
case 26:
{ memo_oper_ampersand(); }
break;
case 27:
{ memo_oper_asterisk(); }
break;
case 28:
{ memo_oper_mono_plus(); }
break;
case 29:
{ memo_oper_mono_minus();}
break;
case 30:
{ memo_oper_complement();}
break;
case 31:
{ memo_oper_not(); }
break;
case 33:
{ memo_cast(); }
break;
case 35:
{ memo_binary_oper("*"); }
break;
case 36:
{ memo_binary_oper("/"); }
break;
case 37:
{ memo_binary_oper("%"); }
break;
case 39:
{ memo_binary_oper("+"); }
break;
case 40:
{ memo_binary_oper("-"); }
break;
case 42:
{ memo_binary_oper("<<"); }
break;
case 43:
{ memo_binary_oper(">>"); }
break;
case 45:
{ memo_binary_oper("<"); }
break;
case 46:
{ memo_binary_oper(">"); }
break;
case 47:
{ memo_binary_oper("<="); }
break;
case 48:
{ memo_binary_oper(">="); }
break;
case 50:
{ memo_binary_oper("=="); }
break;
case 51:
{ memo_binary_oper("!="); }
break;
case 53:
{ memo_binary_oper("&"); }
break;
case 55:
{ memo_binary_oper("^"); }
break;
case 57:
{ memo_binary_oper("|"); }
break;
case 59:
{ memo_binary_oper("&&"); }
break;
case 61:
{ memo_binary_oper("||"); }
break;
case 63:
{ memo_arith_if(); }
break;
case 65:
{ memo_assignment(); }
break;
case 66:
{ memo_identifier(yytext); }
break;
case 79:
{ memo_comma(); }
break;
case 82:
{ memo_negate_integer(yytext); }
break;
case 83:
{ memo_no_comma_expression(); }
break;
case 85:
{ if (!partial_declaration()) YYABORT; }
break;
case 86:
{ if (!declaration()) YYABORT; }
break;
case 91:
{ memo_typedef(Type_Int); }
break;
case 92:
{ memo_typedef(Type_Char); }
break;
case 93:
{ memo_typedef(Type_Void); }
break;
case 95:
{ memo_ellipsis(); }
break;
case 98:
{ if (!ignored_param()) YYABORT; }
break;
case 99:
{ if (!ignored_param()) YYABORT; }
break;
case 100:
{ if (!typed_param()) YYABORT; }
break;
case 105:
{ mark_no_initializer(); }
break;
case 107:
{ mark_begin_initializer_list(); }
break;
case 108:
{ memo_initializer_list(); }
break;
case 115:
{ memo_string(yytext); }
break;
case 124:
{ memo_case(); }
break;
case 126:
{ memo_default(); }
break;
case 128:
{ mark_begin_block(); }
break;
case 129:
{ memo_empty_block(); }
break;
case 130:
{ memo_block(); }
break;
case 131:
{ memo_block(); }
break;
case 132:
{ memo_block(); }
break;
case 138:
{ memo_if();}
break;
case 139:
{ memo_if_else();}
break;
case 140:
{ memo_switch();}
break;
case 141:
{ memo_while(); }
break;
case 142:
{ memo_do_while(); }
break;
case 143:
{ memo_for(); }
break;
case 144:
{ memo_continue(); }
break;
case 145:
{ memo_break(); }
break;
case 146:
{ memo_return(); }
break;
case 147:
{ YYACCEPT; }
break;
case 148:
{ YYACCEPT; }
break;
case 149:
{ YYACCEPT; }
break;
case 150:
{ if (*yytext)
				    yyerror(yytext);
				  YYABORT; }
break;
case 151:
{ memo_make_function_def(); }
break;
case 152:
{ memo_make_typedef_function_def(); }
break;
case 153:
{ memo_make_oldfunction_def_without_decllist(); }
break;
case 154:
{ memo_make_typedef_oldfunction_def_without_decllist(); }
break;
case 155:
{ memo_make_oldfunction_def(); }
break;
case 156:
{ memo_make_typedef_oldfunction_def(); }
break;
case 159:
{ mark_no_initializer(); if (!declaration()) YYABORT; }
break;
case 161:
{ mark_no_initializer(); }
break;
case 164:
{ mark_asterisk(); }
break;
case 169:
{ mark_begin_of_list(); }
break;
case 170:
{ end_of_list(); }
break;
case 171:
{ forget_list(); }
break;
case 172:
{ forget_list_if_possible(); }
break;
case 180:
{ mark_begin_identifier_list(); }
break;
case 181:
{ end_identifier_list(); }
break;
case 187:
{ array_abstract_declarator(); }
break;
case 188:
{ memo_empty_function_parameter_type_list(); }
break;
case 189:
{ mark_begin_function_parameter_type_list(); }
break;
case 190:
{ end_function_parameter_type_list(); }
break;
case 191:
{ memo_array_decl_without_dim(); }
break;
case 192:
{ memo_array_decl_dim(); }
break;
case 193:
{ memo_array_decl_dim(); }
break;
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
